var _excluded = ["portal", "getComboDOM", "maskClosable", "value", "list", "onBeforeChange", "onChange", "visible", "onVisibleChange", "maskProps", "wrapperProps", "submitProps", "cancelProps", "ranges", "type", "min", "max", "onError"];

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

// require PrototypeDate.js和PrototypeString.js
import React, { forwardRef, useRef, useEffect } from 'react';
import Modal from "./../../Modal";
import Quick from "./Quick";
import Custom from "./Custom"; // 用于计算弹窗位置

import TooltipUtils from "../../Tooltip/Utils";
var RangeModal = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var portal = _ref.portal,
      getComboDOM = _ref.getComboDOM,
      _ref$maskClosable = _ref.maskClosable,
      maskClosable = _ref$maskClosable === void 0 ? true : _ref$maskClosable,
      value = _ref.value,
      list = _ref.list,
      onBeforeChange = _ref.onBeforeChange,
      onChange = _ref.onChange,
      _ref$visible = _ref.visible,
      visible = _ref$visible === void 0 ? false : _ref$visible,
      onVisibleChange = _ref.onVisibleChange,
      _ref$maskProps = _ref.maskProps,
      maskProps = _ref$maskProps === void 0 ? {} : _ref$maskProps,
      _ref$wrapperProps = _ref.wrapperProps,
      wrapperProps = _ref$wrapperProps === void 0 ? {} : _ref$wrapperProps,
      _ref$submitProps = _ref.submitProps,
      submitProps = _ref$submitProps === void 0 ? {} : _ref$submitProps,
      _ref$cancelProps = _ref.cancelProps,
      cancelProps = _ref$cancelProps === void 0 ? {} : _ref$cancelProps,
      ranges = _ref.ranges,
      _ref$type = _ref.type,
      type = _ref$type === void 0 ? 'date' : _ref$type,
      min = _ref.min,
      max = _ref.max,
      onError = _ref.onError,
      props = _objectWithoutProperties(_ref, _excluded);

  var modalRef = useRef(null); // ranges分成两部分: quickRanges(快捷选择)和customRanges(自定义选择)

  var quickRanges = {};
  var customRanges = {};

  for (var rangeKey in ranges) {
    var rangeValue = ranges[rangeKey];

    if (Array.isArray(rangeValue) && rangeValue.length === 2 && rangeValue[0] instanceof Date && rangeValue[1] instanceof Date) {
      quickRanges[rangeKey] = rangeValue;
    } else {
      // 自定义选择只能有一个
      customRanges = _defineProperty({}, rangeKey, rangeValue);
    }
  } // 受控显隐时, 需要更新容器位置


  useEffect(function () {
    var _maskProps$style, _maskProps$style2;

    var modalDOM = modalRef.current.rootDOM;
    var comboDOM = null;

    if (typeof getComboDOM === 'function') {
      var _comboDOM;

      comboDOM = getComboDOM();

      if (typeof ((_comboDOM = comboDOM) === null || _comboDOM === void 0 ? void 0 : _comboDOM.getRootDOM) === 'function') {
        comboDOM = comboDOM.getRootDOM();
      }
    }

    if (visible && comboDOM && modalDOM && !(maskProps !== null && maskProps !== void 0 && (_maskProps$style = maskProps.style) !== null && _maskProps$style !== void 0 && _maskProps$style.top) && !(maskProps !== null && maskProps !== void 0 && (_maskProps$style2 = maskProps.style) !== null && _maskProps$style2 !== void 0 && _maskProps$style2.bottom)) {
      TooltipUtils.updateContainerPosition({
        source: comboDOM,
        target: modalDOM,
        animation: 'slideDown'
      });
    }
  }, [visible]); // eslint-disable-line
  // 如果没有快捷选择, 直接渲染自定义选择

  if (Object.isEmptyObject(quickRanges)) {
    return null;
  } // 返回快捷选择


  return /*#__PURE__*/React.createElement(Modal, _extends({
    ref: modalRef,
    maskClosable: maskClosable,
    visible: visible,
    animation: "slideDown",
    className: "datepicker-rangemodal-modal",
    onVisibleChange: onVisibleChange
  }, props), /*#__PURE__*/React.createElement(Quick, {
    ranges: quickRanges,
    onBeforeChange: onBeforeChange,
    onChange: onChange,
    onVisibleChange: onVisibleChange
  }), /*#__PURE__*/React.createElement(Custom, {
    maskClosable: maskClosable,
    value: value,
    ranges: customRanges,
    type: type,
    min: min,
    max: max,
    onError: onError,
    onBeforeChange: onBeforeChange,
    onChange: onChange,
    onVisibleChange: onVisibleChange
  }));
});
export default RangeModal;